SystemOrganization addCategory: #Parcial_RogerHernandoBuch!

Object subclass: #Parcial_RogerHernandoBuch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parcial_RogerHernandoBuch'!

!Parcial_RogerHernandoBuch methodsFor: 'Preguntes' stamp: 'RogerHernando 11/9/2012 01:44'!
pregunta1
"He implementat la classe matriu amb una OrderedCollection de mida NxN. 
Com a parells he utilitzat Point.

Com a cosa especial he protegit el setter de N perque noms es pugui fer una vegada i no es pugui redefinir N en temps d'execuci. Tot i que s frequent en smalltalk fer setters i getters lliures per a tot.


Observacions:
Els index de la matriu van de (0,0) a (N-1, N-1)
He redefinit el printOn
"

"Exemples d'us:"
|mat|
mat := Matriu new: 2.
Transcript show: (mat);cr.
mat at: (Point x:0 y: 0) put: 1.
Transcript show: (mat);cr.
mat at: (Point x:0 y: 1) put: 2.
Transcript show: (mat);cr.
mat at: (Point x:1 y: 0) put: 3.
Transcript show: (mat);cr.
mat at: (Point x:1 y: 1) put: 4.
Transcript show: (mat);cr.
Transcript show: (mat at:(Point x:1 y: 1)  );cr.

! !

!Parcial_RogerHernandoBuch methodsFor: 'Preguntes' stamp: 'RogerHernando 11/8/2012 23:10'!
pregunta2
"
Explica qu vol dir introspecci, intercessi i reificaci.

Introspecci: Habilitat d'un programa d'observar el seu estat intern.

Intercessi: Habilitat d'un programa per modificar el seu estat intern i automodificar-se.

Reificaci: Es la possibilitat del llenguatge d'oferir el mecanisme que ens codifica l'estat intern d'un programa, tant introspecci com intersecci necessiten aquesta representaci de l'estat. 

Smalltalk i Java sn reflexius del tot? Perqu?

Java i Smalltalk no son llenguatges reflexius del tot.

Java no es un llenguatge completament reflexiu ja que no ens permet per intercessi del contingut de la pila d'execuci per exemple a part que te un sistema de meta-classes mes pobre que el de Smalltalk.

Smalltalk no es reflectiu del tot perqu no permet reificar el pas de missatges. Si que permet fer intercessi i introspecci estructural, tanmateix no permet una intercessi i introspecci de comportament total.

Quin dels dos s'acosta mes?

El que me s'acosta a ser un llenguatge reflexiu del tot es Smalltalk ja que implementa una reflexi estructural completa i una reflexi de comportament limitada, mentre que java implementa una reflexi estructural limitada. A mes a mes Smalltalk s el que implementa els mecanismes reflexius de forma mes clara i neta.
"

! !

!Parcial_RogerHernandoBuch methodsFor: 'Preguntes' stamp: 'RogerHernando 11/9/2012 00:35'!
pregunta3
"
Per qu cal que tant Java com Smalltalk tinguin metaclasses?

Les meta-clases son all que un llenguatge necessita per poder oferir reflexi estructural. Ja que les meta-classes ens ofereixen una descripci de l'estructura i comportament de les classes.
Tant java com Smalltalk implementen un sistema de meta-classes per tal d'oferir aquest tipus de reflexi.

Quina diferncia hi ha entre Java i Smalltalk en el que respecta les meta-classes?

Smalltalk te una meta-classe per a cada classe, i java noms te una nica meta-classe per a totes les classes el que fa que en el cas de java no es pugui fer intersecci directe sobre les classes ja que totes elles son instancies de Class.
"! !

!Parcial_RogerHernandoBuch methodsFor: 'Preguntes' stamp: 'RogerHernando 11/8/2012 23:50'!
pregunta4
"
Suposem que dins un mtode qualsevol m retorno explcitament un valor mitjanant ^expressi. Respecte a thisContext (avaluat dins) de m, on retorna ^expressi?

Retornar al context del mtode que hagi cridat al mtode m, concretament a thisContext sender.

I si el que passa s que dins d'aquest mateix mtode m el que s'avalua s un bloc que cont ^expressi? 

Retornara en el context on s'hagi creat el bloc ja que la bloc guarda el context on es crea i per a ell el context del moment de la seva creaci es el seu context actual.

De quina classe sn instncies els elements de la pila d'execuci que reifica thisContext?

De la classe MethodContext.
"! !

!Parcial_RogerHernandoBuch methodsFor: 'Preguntes' stamp: 'RogerHernando 11/8/2012 23:55'!
"basicament el haltif de les transpes"
pregunta5: aSelector
	| context |
	context := thisContext.
	[context sender isNil]
	whileFalse:
		[context := context sender.
		(context selector = aSelector)
		ifTrue: [ Halt signal ] ].! !

!Parcial_RogerHernandoBuch methodsFor: 'Preguntes' stamp: 'RogerHernando 11/9/2012 00:32'!
pregunta6
"
Tot seguit t'adjunto el codi clau del haltif en java, tanmateix tamb t'adjuntar, el haltif.java per a mes comoditat amb un main d'exemple.

Codi Java:

public static void haltif(String selector){
		StackTraceElement[] stackTrace = (new Throwable()).getStackTrace();
		/*
		 * Comeno el bucle des de 1, ja que no crec apropiat que haltif(''haltif'') s'aturi.
		 * Tanmateix si afegisim la crida haltif(''haltif'') dins d'un altre haltif, si que s'aturaria l'execuci.
		 */
		for (int i = 1; i < stackTrace.length; ++i) {
		    if(stackTrace[i].getMethodName().equals(selector))
		    	System.exit(0);
		}
	}
"! !

OrderedCollection subclass: #Matriu
	instanceVariableNames: 'N'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parcial_RogerHernandoBuch'!

!Matriu class methodsFor: 'as yet unclassified' stamp: 'RogerHernando 11/6/2012 23:13'!
new: unNombre
	|aux|
	aux:= unNombre*unNombre.
	^(self new: aux withAll: 0) n: unNombre! !

!Matriu methodsFor: 'as yet unclassified' stamp: 'RogerHernando 11/9/2012 01:19'!
at: unParell
"he utilitzat els punts com a parells"
unParell class = Point
ifTrue:  [^super at:((N*(unParell x)+unParell y )+1)]
ifFalse: [^super at: unParell ].! !

!Matriu methodsFor: 'as yet unclassified' stamp: 'RogerHernando 11/9/2012 01:19'!
at: unParell put: unValor
"He utilitzat els punts com a parells"
unParell class = Point
ifTrue:  [^super at:( (N*(unParell x)+unParell y )+ 1) put: unValor]
ifFalse: [^super at: unParell put: unValor].! !

!Matriu methodsFor: 'accessing' stamp: 'RogerHernando 11/6/2012 23:00'!
n
	^ N! !

!Matriu methodsFor: 'accessing' stamp: 'RogerHernando 11/6/2012 23:51'!
n: anObject
"He de protegir N per que no es pugui redefinir durant l'execuci"
	N isNil 
	ifTrue: [N := anObject]
	ifFalse: [self error: 'no es pot redefinir N'].! !

!Matriu methodsFor: 'printing' stamp: 'RogerHernando 11/9/2012 01:43'!
printOn: aStream
	|x|
	x:=0.
	(N) timesRepeat: 
	[
		|y|
		y:=0.
		(N) timesRepeat: 
		[
			aStream  print: (self at: (Point x: x y: y)). 
			aStream nextPut: Character space.
			y:=y+1.
		].
		aStream nextPut: Character cr.
		"aStream print: (Character cr) asString."
		x:=x+1.
	].
! !
